// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: subscriptions.proto

#include "subscriptions.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class SubscribeMessageDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<SubscribeMessage>
      _instance;
} _SubscribeMessage_default_instance_;
class SubscribeReply_ErrorDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<SubscribeReply_Error>
      _instance;
} _SubscribeReply_Error_default_instance_;
class SubscribeReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<SubscribeReply>
      _instance;
} _SubscribeReply_default_instance_;
class UnsubscribeMessageDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<UnsubscribeMessage>
      _instance;
} _UnsubscribeMessage_default_instance_;
class UnsubscribeReply_ErrorDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<UnsubscribeReply_Error>
      _instance;
} _UnsubscribeReply_Error_default_instance_;
class UnsubscribeReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<UnsubscribeReply>
      _instance;
} _UnsubscribeReply_default_instance_;
}  // namespace mascot
namespace protobuf_subscriptions_2eproto {
void InitDefaultsSubscribeMessageImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_SubscribeMessage_default_instance_;
    new (ptr) ::mascot::SubscribeMessage();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::SubscribeMessage::InitAsDefaultInstance();
}

void InitDefaultsSubscribeMessage() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsSubscribeMessageImpl);
}

void InitDefaultsSubscribeReply_ErrorImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_SubscribeReply_Error_default_instance_;
    new (ptr) ::mascot::SubscribeReply_Error();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::SubscribeReply_Error::InitAsDefaultInstance();
}

void InitDefaultsSubscribeReply_Error() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsSubscribeReply_ErrorImpl);
}

void InitDefaultsSubscribeReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_subscriptions_2eproto::InitDefaultsSubscribeReply_Error();
  {
    void* ptr = &::mascot::_SubscribeReply_default_instance_;
    new (ptr) ::mascot::SubscribeReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::SubscribeReply::InitAsDefaultInstance();
}

void InitDefaultsSubscribeReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsSubscribeReplyImpl);
}

void InitDefaultsUnsubscribeMessageImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_UnsubscribeMessage_default_instance_;
    new (ptr) ::mascot::UnsubscribeMessage();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::UnsubscribeMessage::InitAsDefaultInstance();
}

void InitDefaultsUnsubscribeMessage() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsUnsubscribeMessageImpl);
}

void InitDefaultsUnsubscribeReply_ErrorImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_UnsubscribeReply_Error_default_instance_;
    new (ptr) ::mascot::UnsubscribeReply_Error();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::UnsubscribeReply_Error::InitAsDefaultInstance();
}

void InitDefaultsUnsubscribeReply_Error() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsUnsubscribeReply_ErrorImpl);
}

void InitDefaultsUnsubscribeReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReply_Error();
  {
    void* ptr = &::mascot::_UnsubscribeReply_default_instance_;
    new (ptr) ::mascot::UnsubscribeReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::UnsubscribeReply::InitAsDefaultInstance();
}

void InitDefaultsUnsubscribeReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsUnsubscribeReplyImpl);
}

::google::protobuf::Metadata file_level_metadata[6];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeMessage, devicename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeMessage, attributename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeMessage, flavor_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeReply_Error, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeReply_Error, code_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeReply_Error, message_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeReply, success_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::SubscribeReply, error_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeMessage, devicename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeMessage, attributename_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeReply_Error, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeReply_Error, code_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeReply_Error, message_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeReply, success_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::UnsubscribeReply, error_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::SubscribeMessage)},
  { 8, -1, sizeof(::mascot::SubscribeReply_Error)},
  { 15, -1, sizeof(::mascot::SubscribeReply)},
  { 22, -1, sizeof(::mascot::UnsubscribeMessage)},
  { 29, -1, sizeof(::mascot::UnsubscribeReply_Error)},
  { 36, -1, sizeof(::mascot::UnsubscribeReply)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_SubscribeMessage_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_SubscribeReply_Error_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_SubscribeReply_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_UnsubscribeMessage_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_UnsubscribeReply_Error_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_UnsubscribeReply_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "subscriptions.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 6);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\023subscriptions.proto\022\006mascot\032\013enums.pro"
      "to\"i\n\020SubscribeMessage\022\022\n\ndeviceName\030\001 \001"
      "(\t\022\025\n\rattributeName\030\002 \001(\t\022*\n\006flavor\030\003 \001("
      "\0162\032.mascot.SubscriptionFlavor\"v\n\016Subscri"
      "beReply\022\017\n\007success\030\001 \001(\010\022+\n\005error\030\002 \001(\0132"
      "\034.mascot.SubscribeReply.Error\032&\n\005Error\022\014"
      "\n\004code\030\001 \001(\003\022\017\n\007message\030\002 \001(\t\"\?\n\022Unsubsc"
      "ribeMessage\022\022\n\ndeviceName\030\001 \001(\t\022\025\n\rattri"
      "buteName\030\002 \001(\t\"z\n\020UnsubscribeReply\022\017\n\007su"
      "ccess\030\001 \001(\010\022-\n\005error\030\002 \001(\0132\036.mascot.Unsu"
      "bscribeReply.Error\032&\n\005Error\022\014\n\004code\030\001 \001("
      "\003\022\017\n\007message\030\002 \001(\tb\006proto3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 466);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "subscriptions.proto", &protobuf_RegisterTypes);
  ::protobuf_enums_2eproto::AddDescriptors();
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_subscriptions_2eproto
namespace mascot {

// ===================================================================

void SubscribeMessage::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int SubscribeMessage::kDeviceNameFieldNumber;
const int SubscribeMessage::kAttributeNameFieldNumber;
const int SubscribeMessage::kFlavorFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

SubscribeMessage::SubscribeMessage()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeMessage();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.SubscribeMessage)
}
SubscribeMessage::SubscribeMessage(const SubscribeMessage& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.devicename().size() > 0) {
    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.attributename().size() > 0) {
    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
  flavor_ = from.flavor_;
  // @@protoc_insertion_point(copy_constructor:mascot.SubscribeMessage)
}

void SubscribeMessage::SharedCtor() {
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  flavor_ = 0;
  _cached_size_ = 0;
}

SubscribeMessage::~SubscribeMessage() {
  // @@protoc_insertion_point(destructor:mascot.SubscribeMessage)
  SharedDtor();
}

void SubscribeMessage::SharedDtor() {
  devicename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void SubscribeMessage::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* SubscribeMessage::descriptor() {
  ::protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const SubscribeMessage& SubscribeMessage::default_instance() {
  ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeMessage();
  return *internal_default_instance();
}

SubscribeMessage* SubscribeMessage::New(::google::protobuf::Arena* arena) const {
  SubscribeMessage* n = new SubscribeMessage;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void SubscribeMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.SubscribeMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  flavor_ = 0;
  _internal_metadata_.Clear();
}

bool SubscribeMessage::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.SubscribeMessage)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string deviceName = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_devicename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->devicename().data(), static_cast<int>(this->devicename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.SubscribeMessage.deviceName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string attributeName = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_attributename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->attributename().data(), static_cast<int>(this->attributename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.SubscribeMessage.attributeName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.SubscriptionFlavor flavor = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          set_flavor(static_cast< ::mascot::SubscriptionFlavor >(value));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.SubscribeMessage)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.SubscribeMessage)
  return false;
#undef DO_
}

void SubscribeMessage::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.SubscribeMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.SubscribeMessage.deviceName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->devicename(), output);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.SubscribeMessage.attributeName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->attributename(), output);
  }

  // .mascot.SubscriptionFlavor flavor = 3;
  if (this->flavor() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      3, this->flavor(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.SubscribeMessage)
}

::google::protobuf::uint8* SubscribeMessage::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.SubscribeMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.SubscribeMessage.deviceName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->devicename(), target);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.SubscribeMessage.attributeName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->attributename(), target);
  }

  // .mascot.SubscriptionFlavor flavor = 3;
  if (this->flavor() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      3, this->flavor(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.SubscribeMessage)
  return target;
}

size_t SubscribeMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.SubscribeMessage)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->devicename());
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->attributename());
  }

  // .mascot.SubscriptionFlavor flavor = 3;
  if (this->flavor() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->flavor());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void SubscribeMessage::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.SubscribeMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const SubscribeMessage* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const SubscribeMessage>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.SubscribeMessage)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.SubscribeMessage)
    MergeFrom(*source);
  }
}

void SubscribeMessage::MergeFrom(const SubscribeMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.SubscribeMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.devicename().size() > 0) {

    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  if (from.attributename().size() > 0) {

    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
  if (from.flavor() != 0) {
    set_flavor(from.flavor());
  }
}

void SubscribeMessage::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.SubscribeMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void SubscribeMessage::CopyFrom(const SubscribeMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.SubscribeMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool SubscribeMessage::IsInitialized() const {
  return true;
}

void SubscribeMessage::Swap(SubscribeMessage* other) {
  if (other == this) return;
  InternalSwap(other);
}
void SubscribeMessage::InternalSwap(SubscribeMessage* other) {
  using std::swap;
  devicename_.Swap(&other->devicename_);
  attributename_.Swap(&other->attributename_);
  swap(flavor_, other->flavor_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata SubscribeMessage::GetMetadata() const {
  protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void SubscribeReply_Error::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int SubscribeReply_Error::kCodeFieldNumber;
const int SubscribeReply_Error::kMessageFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

SubscribeReply_Error::SubscribeReply_Error()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeReply_Error();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.SubscribeReply.Error)
}
SubscribeReply_Error::SubscribeReply_Error(const SubscribeReply_Error& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  message_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.message().size() > 0) {
    message_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.message_);
  }
  code_ = from.code_;
  // @@protoc_insertion_point(copy_constructor:mascot.SubscribeReply.Error)
}

void SubscribeReply_Error::SharedCtor() {
  message_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  code_ = GOOGLE_LONGLONG(0);
  _cached_size_ = 0;
}

SubscribeReply_Error::~SubscribeReply_Error() {
  // @@protoc_insertion_point(destructor:mascot.SubscribeReply.Error)
  SharedDtor();
}

void SubscribeReply_Error::SharedDtor() {
  message_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void SubscribeReply_Error::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* SubscribeReply_Error::descriptor() {
  ::protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const SubscribeReply_Error& SubscribeReply_Error::default_instance() {
  ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeReply_Error();
  return *internal_default_instance();
}

SubscribeReply_Error* SubscribeReply_Error::New(::google::protobuf::Arena* arena) const {
  SubscribeReply_Error* n = new SubscribeReply_Error;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void SubscribeReply_Error::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.SubscribeReply.Error)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  message_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  code_ = GOOGLE_LONGLONG(0);
  _internal_metadata_.Clear();
}

bool SubscribeReply_Error::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.SubscribeReply.Error)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // int64 code = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &code_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string message = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_message()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->message().data(), static_cast<int>(this->message().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.SubscribeReply.Error.message"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.SubscribeReply.Error)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.SubscribeReply.Error)
  return false;
#undef DO_
}

void SubscribeReply_Error::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.SubscribeReply.Error)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // int64 code = 1;
  if (this->code() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(1, this->code(), output);
  }

  // string message = 2;
  if (this->message().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->message().data(), static_cast<int>(this->message().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.SubscribeReply.Error.message");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->message(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.SubscribeReply.Error)
}

::google::protobuf::uint8* SubscribeReply_Error::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.SubscribeReply.Error)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // int64 code = 1;
  if (this->code() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(1, this->code(), target);
  }

  // string message = 2;
  if (this->message().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->message().data(), static_cast<int>(this->message().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.SubscribeReply.Error.message");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->message(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.SubscribeReply.Error)
  return target;
}

size_t SubscribeReply_Error::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.SubscribeReply.Error)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string message = 2;
  if (this->message().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->message());
  }

  // int64 code = 1;
  if (this->code() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int64Size(
        this->code());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void SubscribeReply_Error::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.SubscribeReply.Error)
  GOOGLE_DCHECK_NE(&from, this);
  const SubscribeReply_Error* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const SubscribeReply_Error>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.SubscribeReply.Error)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.SubscribeReply.Error)
    MergeFrom(*source);
  }
}

void SubscribeReply_Error::MergeFrom(const SubscribeReply_Error& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.SubscribeReply.Error)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.message().size() > 0) {

    message_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.message_);
  }
  if (from.code() != 0) {
    set_code(from.code());
  }
}

void SubscribeReply_Error::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.SubscribeReply.Error)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void SubscribeReply_Error::CopyFrom(const SubscribeReply_Error& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.SubscribeReply.Error)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool SubscribeReply_Error::IsInitialized() const {
  return true;
}

void SubscribeReply_Error::Swap(SubscribeReply_Error* other) {
  if (other == this) return;
  InternalSwap(other);
}
void SubscribeReply_Error::InternalSwap(SubscribeReply_Error* other) {
  using std::swap;
  message_.Swap(&other->message_);
  swap(code_, other->code_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata SubscribeReply_Error::GetMetadata() const {
  protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void SubscribeReply::InitAsDefaultInstance() {
  ::mascot::_SubscribeReply_default_instance_._instance.get_mutable()->error_ = const_cast< ::mascot::SubscribeReply_Error*>(
      ::mascot::SubscribeReply_Error::internal_default_instance());
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int SubscribeReply::kSuccessFieldNumber;
const int SubscribeReply::kErrorFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

SubscribeReply::SubscribeReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.SubscribeReply)
}
SubscribeReply::SubscribeReply(const SubscribeReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_error()) {
    error_ = new ::mascot::SubscribeReply_Error(*from.error_);
  } else {
    error_ = NULL;
  }
  success_ = from.success_;
  // @@protoc_insertion_point(copy_constructor:mascot.SubscribeReply)
}

void SubscribeReply::SharedCtor() {
  ::memset(&error_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&success_) -
      reinterpret_cast<char*>(&error_)) + sizeof(success_));
  _cached_size_ = 0;
}

SubscribeReply::~SubscribeReply() {
  // @@protoc_insertion_point(destructor:mascot.SubscribeReply)
  SharedDtor();
}

void SubscribeReply::SharedDtor() {
  if (this != internal_default_instance()) delete error_;
}

void SubscribeReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* SubscribeReply::descriptor() {
  ::protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const SubscribeReply& SubscribeReply::default_instance() {
  ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeReply();
  return *internal_default_instance();
}

SubscribeReply* SubscribeReply::New(::google::protobuf::Arena* arena) const {
  SubscribeReply* n = new SubscribeReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void SubscribeReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.SubscribeReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
  success_ = false;
  _internal_metadata_.Clear();
}

bool SubscribeReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.SubscribeReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // bool success = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &success_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.SubscribeReply.Error error = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_error()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.SubscribeReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.SubscribeReply)
  return false;
#undef DO_
}

void SubscribeReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.SubscribeReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->success(), output);
  }

  // .mascot.SubscribeReply.Error error = 2;
  if (this->has_error()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->error_, output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.SubscribeReply)
}

::google::protobuf::uint8* SubscribeReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.SubscribeReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(1, this->success(), target);
  }

  // .mascot.SubscribeReply.Error error = 2;
  if (this->has_error()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->error_, deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.SubscribeReply)
  return target;
}

size_t SubscribeReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.SubscribeReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // .mascot.SubscribeReply.Error error = 2;
  if (this->has_error()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->error_);
  }

  // bool success = 1;
  if (this->success() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void SubscribeReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.SubscribeReply)
  GOOGLE_DCHECK_NE(&from, this);
  const SubscribeReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const SubscribeReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.SubscribeReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.SubscribeReply)
    MergeFrom(*source);
  }
}

void SubscribeReply::MergeFrom(const SubscribeReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.SubscribeReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_error()) {
    mutable_error()->::mascot::SubscribeReply_Error::MergeFrom(from.error());
  }
  if (from.success() != 0) {
    set_success(from.success());
  }
}

void SubscribeReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.SubscribeReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void SubscribeReply::CopyFrom(const SubscribeReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.SubscribeReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool SubscribeReply::IsInitialized() const {
  return true;
}

void SubscribeReply::Swap(SubscribeReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void SubscribeReply::InternalSwap(SubscribeReply* other) {
  using std::swap;
  swap(error_, other->error_);
  swap(success_, other->success_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata SubscribeReply::GetMetadata() const {
  protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void UnsubscribeMessage::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int UnsubscribeMessage::kDeviceNameFieldNumber;
const int UnsubscribeMessage::kAttributeNameFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

UnsubscribeMessage::UnsubscribeMessage()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeMessage();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.UnsubscribeMessage)
}
UnsubscribeMessage::UnsubscribeMessage(const UnsubscribeMessage& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.devicename().size() > 0) {
    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.attributename().size() > 0) {
    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.UnsubscribeMessage)
}

void UnsubscribeMessage::SharedCtor() {
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

UnsubscribeMessage::~UnsubscribeMessage() {
  // @@protoc_insertion_point(destructor:mascot.UnsubscribeMessage)
  SharedDtor();
}

void UnsubscribeMessage::SharedDtor() {
  devicename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void UnsubscribeMessage::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* UnsubscribeMessage::descriptor() {
  ::protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const UnsubscribeMessage& UnsubscribeMessage::default_instance() {
  ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeMessage();
  return *internal_default_instance();
}

UnsubscribeMessage* UnsubscribeMessage::New(::google::protobuf::Arena* arena) const {
  UnsubscribeMessage* n = new UnsubscribeMessage;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void UnsubscribeMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.UnsubscribeMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool UnsubscribeMessage::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.UnsubscribeMessage)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string deviceName = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_devicename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->devicename().data(), static_cast<int>(this->devicename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.UnsubscribeMessage.deviceName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string attributeName = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_attributename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->attributename().data(), static_cast<int>(this->attributename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.UnsubscribeMessage.attributeName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.UnsubscribeMessage)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.UnsubscribeMessage)
  return false;
#undef DO_
}

void UnsubscribeMessage::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.UnsubscribeMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.UnsubscribeMessage.deviceName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->devicename(), output);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.UnsubscribeMessage.attributeName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->attributename(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.UnsubscribeMessage)
}

::google::protobuf::uint8* UnsubscribeMessage::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.UnsubscribeMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.UnsubscribeMessage.deviceName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->devicename(), target);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.UnsubscribeMessage.attributeName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->attributename(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.UnsubscribeMessage)
  return target;
}

size_t UnsubscribeMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.UnsubscribeMessage)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->devicename());
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->attributename());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void UnsubscribeMessage::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.UnsubscribeMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const UnsubscribeMessage* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const UnsubscribeMessage>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.UnsubscribeMessage)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.UnsubscribeMessage)
    MergeFrom(*source);
  }
}

void UnsubscribeMessage::MergeFrom(const UnsubscribeMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.UnsubscribeMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.devicename().size() > 0) {

    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  if (from.attributename().size() > 0) {

    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
}

void UnsubscribeMessage::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.UnsubscribeMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void UnsubscribeMessage::CopyFrom(const UnsubscribeMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.UnsubscribeMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool UnsubscribeMessage::IsInitialized() const {
  return true;
}

void UnsubscribeMessage::Swap(UnsubscribeMessage* other) {
  if (other == this) return;
  InternalSwap(other);
}
void UnsubscribeMessage::InternalSwap(UnsubscribeMessage* other) {
  using std::swap;
  devicename_.Swap(&other->devicename_);
  attributename_.Swap(&other->attributename_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata UnsubscribeMessage::GetMetadata() const {
  protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void UnsubscribeReply_Error::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int UnsubscribeReply_Error::kCodeFieldNumber;
const int UnsubscribeReply_Error::kMessageFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

UnsubscribeReply_Error::UnsubscribeReply_Error()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReply_Error();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.UnsubscribeReply.Error)
}
UnsubscribeReply_Error::UnsubscribeReply_Error(const UnsubscribeReply_Error& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  message_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.message().size() > 0) {
    message_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.message_);
  }
  code_ = from.code_;
  // @@protoc_insertion_point(copy_constructor:mascot.UnsubscribeReply.Error)
}

void UnsubscribeReply_Error::SharedCtor() {
  message_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  code_ = GOOGLE_LONGLONG(0);
  _cached_size_ = 0;
}

UnsubscribeReply_Error::~UnsubscribeReply_Error() {
  // @@protoc_insertion_point(destructor:mascot.UnsubscribeReply.Error)
  SharedDtor();
}

void UnsubscribeReply_Error::SharedDtor() {
  message_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void UnsubscribeReply_Error::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* UnsubscribeReply_Error::descriptor() {
  ::protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const UnsubscribeReply_Error& UnsubscribeReply_Error::default_instance() {
  ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReply_Error();
  return *internal_default_instance();
}

UnsubscribeReply_Error* UnsubscribeReply_Error::New(::google::protobuf::Arena* arena) const {
  UnsubscribeReply_Error* n = new UnsubscribeReply_Error;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void UnsubscribeReply_Error::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.UnsubscribeReply.Error)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  message_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  code_ = GOOGLE_LONGLONG(0);
  _internal_metadata_.Clear();
}

bool UnsubscribeReply_Error::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.UnsubscribeReply.Error)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // int64 code = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &code_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string message = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_message()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->message().data(), static_cast<int>(this->message().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.UnsubscribeReply.Error.message"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.UnsubscribeReply.Error)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.UnsubscribeReply.Error)
  return false;
#undef DO_
}

void UnsubscribeReply_Error::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.UnsubscribeReply.Error)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // int64 code = 1;
  if (this->code() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(1, this->code(), output);
  }

  // string message = 2;
  if (this->message().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->message().data(), static_cast<int>(this->message().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.UnsubscribeReply.Error.message");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->message(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.UnsubscribeReply.Error)
}

::google::protobuf::uint8* UnsubscribeReply_Error::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.UnsubscribeReply.Error)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // int64 code = 1;
  if (this->code() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(1, this->code(), target);
  }

  // string message = 2;
  if (this->message().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->message().data(), static_cast<int>(this->message().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.UnsubscribeReply.Error.message");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->message(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.UnsubscribeReply.Error)
  return target;
}

size_t UnsubscribeReply_Error::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.UnsubscribeReply.Error)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string message = 2;
  if (this->message().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->message());
  }

  // int64 code = 1;
  if (this->code() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int64Size(
        this->code());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void UnsubscribeReply_Error::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.UnsubscribeReply.Error)
  GOOGLE_DCHECK_NE(&from, this);
  const UnsubscribeReply_Error* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const UnsubscribeReply_Error>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.UnsubscribeReply.Error)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.UnsubscribeReply.Error)
    MergeFrom(*source);
  }
}

void UnsubscribeReply_Error::MergeFrom(const UnsubscribeReply_Error& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.UnsubscribeReply.Error)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.message().size() > 0) {

    message_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.message_);
  }
  if (from.code() != 0) {
    set_code(from.code());
  }
}

void UnsubscribeReply_Error::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.UnsubscribeReply.Error)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void UnsubscribeReply_Error::CopyFrom(const UnsubscribeReply_Error& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.UnsubscribeReply.Error)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool UnsubscribeReply_Error::IsInitialized() const {
  return true;
}

void UnsubscribeReply_Error::Swap(UnsubscribeReply_Error* other) {
  if (other == this) return;
  InternalSwap(other);
}
void UnsubscribeReply_Error::InternalSwap(UnsubscribeReply_Error* other) {
  using std::swap;
  message_.Swap(&other->message_);
  swap(code_, other->code_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata UnsubscribeReply_Error::GetMetadata() const {
  protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void UnsubscribeReply::InitAsDefaultInstance() {
  ::mascot::_UnsubscribeReply_default_instance_._instance.get_mutable()->error_ = const_cast< ::mascot::UnsubscribeReply_Error*>(
      ::mascot::UnsubscribeReply_Error::internal_default_instance());
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int UnsubscribeReply::kSuccessFieldNumber;
const int UnsubscribeReply::kErrorFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

UnsubscribeReply::UnsubscribeReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.UnsubscribeReply)
}
UnsubscribeReply::UnsubscribeReply(const UnsubscribeReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_error()) {
    error_ = new ::mascot::UnsubscribeReply_Error(*from.error_);
  } else {
    error_ = NULL;
  }
  success_ = from.success_;
  // @@protoc_insertion_point(copy_constructor:mascot.UnsubscribeReply)
}

void UnsubscribeReply::SharedCtor() {
  ::memset(&error_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&success_) -
      reinterpret_cast<char*>(&error_)) + sizeof(success_));
  _cached_size_ = 0;
}

UnsubscribeReply::~UnsubscribeReply() {
  // @@protoc_insertion_point(destructor:mascot.UnsubscribeReply)
  SharedDtor();
}

void UnsubscribeReply::SharedDtor() {
  if (this != internal_default_instance()) delete error_;
}

void UnsubscribeReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* UnsubscribeReply::descriptor() {
  ::protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const UnsubscribeReply& UnsubscribeReply::default_instance() {
  ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReply();
  return *internal_default_instance();
}

UnsubscribeReply* UnsubscribeReply::New(::google::protobuf::Arena* arena) const {
  UnsubscribeReply* n = new UnsubscribeReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void UnsubscribeReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.UnsubscribeReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
  success_ = false;
  _internal_metadata_.Clear();
}

bool UnsubscribeReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.UnsubscribeReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // bool success = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &success_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.UnsubscribeReply.Error error = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_error()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.UnsubscribeReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.UnsubscribeReply)
  return false;
#undef DO_
}

void UnsubscribeReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.UnsubscribeReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->success(), output);
  }

  // .mascot.UnsubscribeReply.Error error = 2;
  if (this->has_error()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->error_, output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.UnsubscribeReply)
}

::google::protobuf::uint8* UnsubscribeReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.UnsubscribeReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(1, this->success(), target);
  }

  // .mascot.UnsubscribeReply.Error error = 2;
  if (this->has_error()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->error_, deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.UnsubscribeReply)
  return target;
}

size_t UnsubscribeReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.UnsubscribeReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // .mascot.UnsubscribeReply.Error error = 2;
  if (this->has_error()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->error_);
  }

  // bool success = 1;
  if (this->success() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void UnsubscribeReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.UnsubscribeReply)
  GOOGLE_DCHECK_NE(&from, this);
  const UnsubscribeReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const UnsubscribeReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.UnsubscribeReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.UnsubscribeReply)
    MergeFrom(*source);
  }
}

void UnsubscribeReply::MergeFrom(const UnsubscribeReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.UnsubscribeReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_error()) {
    mutable_error()->::mascot::UnsubscribeReply_Error::MergeFrom(from.error());
  }
  if (from.success() != 0) {
    set_success(from.success());
  }
}

void UnsubscribeReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.UnsubscribeReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void UnsubscribeReply::CopyFrom(const UnsubscribeReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.UnsubscribeReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool UnsubscribeReply::IsInitialized() const {
  return true;
}

void UnsubscribeReply::Swap(UnsubscribeReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void UnsubscribeReply::InternalSwap(UnsubscribeReply* other) {
  using std::swap;
  swap(error_, other->error_);
  swap(success_, other->success_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata UnsubscribeReply::GetMetadata() const {
  protobuf_subscriptions_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_subscriptions_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
